<!DOCTYPE HTML>
<html lang="en">
<head>
<!-- Generated by javadoc (21) -->
<title>Source code</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="description" content="source: package: org.apache.commons.cli, class: DefaultParser">
<meta name="generator" content="javadoc/SourceToHTMLConverter">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body class="source-page">
<main role="main">
<div class="source-container">
<pre><span class="source-line-no">001</span><span id="line-1">/*</span>
<span class="source-line-no">002</span><span id="line-2">  Licensed to the Apache Software Foundation (ASF) under one or more</span>
<span class="source-line-no">003</span><span id="line-3">  contributor license agreements.  See the NOTICE file distributed with</span>
<span class="source-line-no">004</span><span id="line-4">  this work for additional information regarding copyright ownership.</span>
<span class="source-line-no">005</span><span id="line-5">  The ASF licenses this file to You under the Apache License, Version 2.0</span>
<span class="source-line-no">006</span><span id="line-6">  (the "License"); you may not use this file except in compliance with</span>
<span class="source-line-no">007</span><span id="line-7">  the License.  You may obtain a copy of the License at</span>
<span class="source-line-no">008</span><span id="line-8"></span>
<span class="source-line-no">009</span><span id="line-9">      http://www.apache.org/licenses/LICENSE-2.0</span>
<span class="source-line-no">010</span><span id="line-10"></span>
<span class="source-line-no">011</span><span id="line-11">  Unless required by applicable law or agreed to in writing, software</span>
<span class="source-line-no">012</span><span id="line-12">  distributed under the License is distributed on an "AS IS" BASIS,</span>
<span class="source-line-no">013</span><span id="line-13">  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</span>
<span class="source-line-no">014</span><span id="line-14">  See the License for the specific language governing permissions and</span>
<span class="source-line-no">015</span><span id="line-15">  limitations under the License.</span>
<span class="source-line-no">016</span><span id="line-16"> */</span>
<span class="source-line-no">017</span><span id="line-17"></span>
<span class="source-line-no">018</span><span id="line-18">package org.apache.commons.cli;</span>
<span class="source-line-no">019</span><span id="line-19"></span>
<span class="source-line-no">020</span><span id="line-20">import java.util.ArrayList;</span>
<span class="source-line-no">021</span><span id="line-21">import java.util.Enumeration;</span>
<span class="source-line-no">022</span><span id="line-22">import java.util.List;</span>
<span class="source-line-no">023</span><span id="line-23">import java.util.Properties;</span>
<span class="source-line-no">024</span><span id="line-24"></span>
<span class="source-line-no">025</span><span id="line-25">/**</span>
<span class="source-line-no">026</span><span id="line-26"> * Default parser.</span>
<span class="source-line-no">027</span><span id="line-27"> *</span>
<span class="source-line-no">028</span><span id="line-28"> * @since 1.3</span>
<span class="source-line-no">029</span><span id="line-29"> */</span>
<span class="source-line-no">030</span><span id="line-30">public class DefaultParser implements CommandLineParser {</span>
<span class="source-line-no">031</span><span id="line-31"></span>
<span class="source-line-no">032</span><span id="line-32">    /**</span>
<span class="source-line-no">033</span><span id="line-33">     * A nested builder class to create {@code DefaultParser} instances</span>
<span class="source-line-no">034</span><span id="line-34">     * using descriptive methods.</span>
<span class="source-line-no">035</span><span id="line-35">     *</span>
<span class="source-line-no">036</span><span id="line-36">     * Example usage:</span>
<span class="source-line-no">037</span><span id="line-37">     * &lt;pre&gt;</span>
<span class="source-line-no">038</span><span id="line-38">     * DefaultParser parser = Option.builder()</span>
<span class="source-line-no">039</span><span id="line-39">     *     .setAllowPartialMatching(false)</span>
<span class="source-line-no">040</span><span id="line-40">     *     .setStripLeadingAndTrailingQuotes(false)</span>
<span class="source-line-no">041</span><span id="line-41">     *     .build();</span>
<span class="source-line-no">042</span><span id="line-42">     * &lt;/pre&gt;</span>
<span class="source-line-no">043</span><span id="line-43">     *</span>
<span class="source-line-no">044</span><span id="line-44">     * @since 1.5.0</span>
<span class="source-line-no">045</span><span id="line-45">     */</span>
<span class="source-line-no">046</span><span id="line-46">    public static final class Builder {</span>
<span class="source-line-no">047</span><span id="line-47"></span>
<span class="source-line-no">048</span><span id="line-48">        /** Flag indicating if partial matching of long options is supported. */</span>
<span class="source-line-no">049</span><span id="line-49">        private boolean allowPartialMatching = true;</span>
<span class="source-line-no">050</span><span id="line-50"></span>
<span class="source-line-no">051</span><span id="line-51">        /** Flag indicating if balanced leading and trailing double quotes should be stripped from option arguments. */</span>
<span class="source-line-no">052</span><span id="line-52">        private Boolean stripLeadingAndTrailingQuotes;</span>
<span class="source-line-no">053</span><span id="line-53"></span>
<span class="source-line-no">054</span><span id="line-54">        /**</span>
<span class="source-line-no">055</span><span id="line-55">         * Constructs a new {@code Builder} for a {@code DefaultParser} instance.</span>
<span class="source-line-no">056</span><span id="line-56">         *</span>
<span class="source-line-no">057</span><span id="line-57">         * Both allowPartialMatching and stripLeadingAndTrailingQuotes are true by default,</span>
<span class="source-line-no">058</span><span id="line-58">         * mimicking the argument-less constructor.</span>
<span class="source-line-no">059</span><span id="line-59">         */</span>
<span class="source-line-no">060</span><span id="line-60">        private Builder() {</span>
<span class="source-line-no">061</span><span id="line-61">        }</span>
<span class="source-line-no">062</span><span id="line-62"></span>
<span class="source-line-no">063</span><span id="line-63">        /**</span>
<span class="source-line-no">064</span><span id="line-64">         * Builds an DefaultParser with the values declared by this {@link Builder}.</span>
<span class="source-line-no">065</span><span id="line-65">         *</span>
<span class="source-line-no">066</span><span id="line-66">         * @return the new {@link DefaultParser}</span>
<span class="source-line-no">067</span><span id="line-67">         * @since 1.5.0</span>
<span class="source-line-no">068</span><span id="line-68">         */</span>
<span class="source-line-no">069</span><span id="line-69">        public DefaultParser build() {</span>
<span class="source-line-no">070</span><span id="line-70">            return new DefaultParser(allowPartialMatching, stripLeadingAndTrailingQuotes);</span>
<span class="source-line-no">071</span><span id="line-71">        }</span>
<span class="source-line-no">072</span><span id="line-72"></span>
<span class="source-line-no">073</span><span id="line-73">        /**</span>
<span class="source-line-no">074</span><span id="line-74">         * Sets if partial matching of long options is supported.</span>
<span class="source-line-no">075</span><span id="line-75">         *</span>
<span class="source-line-no">076</span><span id="line-76">         * By "partial matching" we mean that given the following code:</span>
<span class="source-line-no">077</span><span id="line-77">         *</span>
<span class="source-line-no">078</span><span id="line-78">         * &lt;pre&gt;</span>
<span class="source-line-no">079</span><span id="line-79">         * {</span>
<span class="source-line-no">080</span><span id="line-80">         *     &amp;#64;code</span>
<span class="source-line-no">081</span><span id="line-81">         *     final Options options = new Options();</span>
<span class="source-line-no">082</span><span id="line-82">         *     options.addOption(new Option("d", "debug", false, "Turn on debug."));</span>
<span class="source-line-no">083</span><span id="line-83">         *     options.addOption(new Option("e", "extract", false, "Turn on extract."));</span>
<span class="source-line-no">084</span><span id="line-84">         *     options.addOption(new Option("o", "option", true, "Turn on option with argument."));</span>
<span class="source-line-no">085</span><span id="line-85">         * }</span>
<span class="source-line-no">086</span><span id="line-86">         * &lt;/pre&gt;</span>
<span class="source-line-no">087</span><span id="line-87">         *</span>
<span class="source-line-no">088</span><span id="line-88">         * If "partial matching" is turned on, {@code -de} only matches the {@code "debug"} option. However, with</span>
<span class="source-line-no">089</span><span id="line-89">         * "partial matching" disabled, {@code -de} would enable both {@code debug} as well as {@code extract}</span>
<span class="source-line-no">090</span><span id="line-90">         *</span>
<span class="source-line-no">091</span><span id="line-91">         * @param allowPartialMatching whether to allow partial matching of long options</span>
<span class="source-line-no">092</span><span id="line-92">         * @return this builder, to allow method chaining</span>
<span class="source-line-no">093</span><span id="line-93">         * @since 1.5.0</span>
<span class="source-line-no">094</span><span id="line-94">         */</span>
<span class="source-line-no">095</span><span id="line-95">        public Builder setAllowPartialMatching(final boolean allowPartialMatching) {</span>
<span class="source-line-no">096</span><span id="line-96">            this.allowPartialMatching = allowPartialMatching;</span>
<span class="source-line-no">097</span><span id="line-97">            return this;</span>
<span class="source-line-no">098</span><span id="line-98">        }</span>
<span class="source-line-no">099</span><span id="line-99"></span>
<span class="source-line-no">100</span><span id="line-100">        /**</span>
<span class="source-line-no">101</span><span id="line-101">         * Sets if balanced leading and trailing double quotes should be stripped from option arguments.</span>
<span class="source-line-no">102</span><span id="line-102">         *</span>
<span class="source-line-no">103</span><span id="line-103">         * If "stripping of balanced leading and trailing double quotes from option arguments" is true,</span>
<span class="source-line-no">104</span><span id="line-104">         * the outermost balanced double quotes of option arguments values will be removed.</span>
<span class="source-line-no">105</span><span id="line-105">         * For example, {@code -o '"x"'} getValue() will return {@code x}, instead of {@code "x"}</span>
<span class="source-line-no">106</span><span id="line-106">         *</span>
<span class="source-line-no">107</span><span id="line-107">         * If "stripping of balanced leading and trailing double quotes from option arguments" is null,</span>
<span class="source-line-no">108</span><span id="line-108">         * then quotes will be stripped from option values separated by space from the option, but</span>
<span class="source-line-no">109</span><span id="line-109">         * kept in other cases, which is the historic behavior.</span>
<span class="source-line-no">110</span><span id="line-110">         *</span>
<span class="source-line-no">111</span><span id="line-111">         * @param stripLeadingAndTrailingQuotes whether balanced leading and trailing double quotes should be stripped from option arguments.</span>
<span class="source-line-no">112</span><span id="line-112">         * @return this builder, to allow method chaining</span>
<span class="source-line-no">113</span><span id="line-113">         * @since 1.5.0</span>
<span class="source-line-no">114</span><span id="line-114">         */</span>
<span class="source-line-no">115</span><span id="line-115">        public Builder setStripLeadingAndTrailingQuotes(final Boolean stripLeadingAndTrailingQuotes) {</span>
<span class="source-line-no">116</span><span id="line-116">            this.stripLeadingAndTrailingQuotes = stripLeadingAndTrailingQuotes;</span>
<span class="source-line-no">117</span><span id="line-117">            return this;</span>
<span class="source-line-no">118</span><span id="line-118">        }</span>
<span class="source-line-no">119</span><span id="line-119">    }</span>
<span class="source-line-no">120</span><span id="line-120"></span>
<span class="source-line-no">121</span><span id="line-121">    /**</span>
<span class="source-line-no">122</span><span id="line-122">     * Creates a new {@link Builder} to create an {@link DefaultParser} using descriptive</span>
<span class="source-line-no">123</span><span id="line-123">     * methods.</span>
<span class="source-line-no">124</span><span id="line-124">     *</span>
<span class="source-line-no">125</span><span id="line-125">     * @return a new {@link Builder} instance</span>
<span class="source-line-no">126</span><span id="line-126">     * @since 1.5.0</span>
<span class="source-line-no">127</span><span id="line-127">     */</span>
<span class="source-line-no">128</span><span id="line-128">    public static Builder builder() {</span>
<span class="source-line-no">129</span><span id="line-129">        return new Builder();</span>
<span class="source-line-no">130</span><span id="line-130">    }</span>
<span class="source-line-no">131</span><span id="line-131"></span>
<span class="source-line-no">132</span><span id="line-132">    /** The command-line instance. */</span>
<span class="source-line-no">133</span><span id="line-133">    protected CommandLine cmd;</span>
<span class="source-line-no">134</span><span id="line-134"></span>
<span class="source-line-no">135</span><span id="line-135">    /** The current options. */</span>
<span class="source-line-no">136</span><span id="line-136">    protected Options options;</span>
<span class="source-line-no">137</span><span id="line-137"></span>
<span class="source-line-no">138</span><span id="line-138">    /**</span>
<span class="source-line-no">139</span><span id="line-139">     * Flag indicating how unrecognized tokens are handled. {@code true} to stop the parsing and add the remaining</span>
<span class="source-line-no">140</span><span id="line-140">     * tokens to the args list. {@code false} to throw an exception.</span>
<span class="source-line-no">141</span><span id="line-141">     */</span>
<span class="source-line-no">142</span><span id="line-142">    protected boolean stopAtNonOption;</span>
<span class="source-line-no">143</span><span id="line-143"></span>
<span class="source-line-no">144</span><span id="line-144">    /** The token currently processed. */</span>
<span class="source-line-no">145</span><span id="line-145">    protected String currentToken;</span>
<span class="source-line-no">146</span><span id="line-146"></span>
<span class="source-line-no">147</span><span id="line-147">    /** The last option parsed. */</span>
<span class="source-line-no">148</span><span id="line-148">    protected Option currentOption;</span>
<span class="source-line-no">149</span><span id="line-149"></span>
<span class="source-line-no">150</span><span id="line-150">    /** Flag indicating if tokens should no longer be analyzed and simply added as arguments of the command line. */</span>
<span class="source-line-no">151</span><span id="line-151">    protected boolean skipParsing;</span>
<span class="source-line-no">152</span><span id="line-152"></span>
<span class="source-line-no">153</span><span id="line-153">    /** The required options and groups expected to be found when parsing the command line. */</span>
<span class="source-line-no">154</span><span id="line-154">    protected List expectedOpts;</span>
<span class="source-line-no">155</span><span id="line-155"></span>
<span class="source-line-no">156</span><span id="line-156">    /** Flag indicating if partial matching of long options is supported. */</span>
<span class="source-line-no">157</span><span id="line-157">    private final boolean allowPartialMatching;</span>
<span class="source-line-no">158</span><span id="line-158"></span>
<span class="source-line-no">159</span><span id="line-159">    /** Flag indicating if balanced leading and trailing double quotes should be stripped from option arguments.</span>
<span class="source-line-no">160</span><span id="line-160">     * null represents the historic arbitrary behavior */</span>
<span class="source-line-no">161</span><span id="line-161">    private final Boolean stripLeadingAndTrailingQuotes;</span>
<span class="source-line-no">162</span><span id="line-162"></span>
<span class="source-line-no">163</span><span id="line-163">    /**</span>
<span class="source-line-no">164</span><span id="line-164">     * Creates a new DefaultParser instance with partial matching enabled.</span>
<span class="source-line-no">165</span><span id="line-165">     *</span>
<span class="source-line-no">166</span><span id="line-166">     * By "partial matching" we mean that given the following code:</span>
<span class="source-line-no">167</span><span id="line-167">     *</span>
<span class="source-line-no">168</span><span id="line-168">     * &lt;pre&gt;</span>
<span class="source-line-no">169</span><span id="line-169">     * {</span>
<span class="source-line-no">170</span><span id="line-170">     *     &amp;#64;code</span>
<span class="source-line-no">171</span><span id="line-171">     *     final Options options = new Options();</span>
<span class="source-line-no">172</span><span id="line-172">     *     options.addOption(new Option("d", "debug", false, "Turn on debug."));</span>
<span class="source-line-no">173</span><span id="line-173">     *     options.addOption(new Option("e", "extract", false, "Turn on extract."));</span>
<span class="source-line-no">174</span><span id="line-174">     *     options.addOption(new Option("o", "option", true, "Turn on option with argument."));</span>
<span class="source-line-no">175</span><span id="line-175">     * }</span>
<span class="source-line-no">176</span><span id="line-176">     * &lt;/pre&gt;</span>
<span class="source-line-no">177</span><span id="line-177">     *</span>
<span class="source-line-no">178</span><span id="line-178">     * with "partial matching" turned on, {@code -de} only matches the {@code "debug"} option. However, with</span>
<span class="source-line-no">179</span><span id="line-179">     * "partial matching" disabled, {@code -de} would enable both {@code debug} as well as {@code extract}</span>
<span class="source-line-no">180</span><span id="line-180">     * options.</span>
<span class="source-line-no">181</span><span id="line-181">     */</span>
<span class="source-line-no">182</span><span id="line-182">    public DefaultParser() {</span>
<span class="source-line-no">183</span><span id="line-183">        this.allowPartialMatching = true;</span>
<span class="source-line-no">184</span><span id="line-184">        this.stripLeadingAndTrailingQuotes = null;</span>
<span class="source-line-no">185</span><span id="line-185">    }</span>
<span class="source-line-no">186</span><span id="line-186"></span>
<span class="source-line-no">187</span><span id="line-187">    /**</span>
<span class="source-line-no">188</span><span id="line-188">     * Create a new DefaultParser instance with the specified partial matching policy.</span>
<span class="source-line-no">189</span><span id="line-189">     *</span>
<span class="source-line-no">190</span><span id="line-190">     * By "partial matching" we mean that given the following code:</span>
<span class="source-line-no">191</span><span id="line-191">     *</span>
<span class="source-line-no">192</span><span id="line-192">     * &lt;pre&gt;</span>
<span class="source-line-no">193</span><span id="line-193">     * {</span>
<span class="source-line-no">194</span><span id="line-194">     *     &amp;#64;code</span>
<span class="source-line-no">195</span><span id="line-195">     *     final Options options = new Options();</span>
<span class="source-line-no">196</span><span id="line-196">     *     options.addOption(new Option("d", "debug", false, "Turn on debug."));</span>
<span class="source-line-no">197</span><span id="line-197">     *     options.addOption(new Option("e", "extract", false, "Turn on extract."));</span>
<span class="source-line-no">198</span><span id="line-198">     *     options.addOption(new Option("o", "option", true, "Turn on option with argument."));</span>
<span class="source-line-no">199</span><span id="line-199">     * }</span>
<span class="source-line-no">200</span><span id="line-200">     * &lt;/pre&gt;</span>
<span class="source-line-no">201</span><span id="line-201">     *</span>
<span class="source-line-no">202</span><span id="line-202">     * with "partial matching" turned on, {@code -de} only matches the {@code "debug"} option. However, with</span>
<span class="source-line-no">203</span><span id="line-203">     * "partial matching" disabled, {@code -de} would enable both {@code debug} as well as {@code extract}</span>
<span class="source-line-no">204</span><span id="line-204">     * options.</span>
<span class="source-line-no">205</span><span id="line-205">     *</span>
<span class="source-line-no">206</span><span id="line-206">     * @param allowPartialMatching if partial matching of long options shall be enabled</span>
<span class="source-line-no">207</span><span id="line-207">     */</span>
<span class="source-line-no">208</span><span id="line-208">    public DefaultParser(final boolean allowPartialMatching) {</span>
<span class="source-line-no">209</span><span id="line-209">        this.allowPartialMatching = allowPartialMatching;</span>
<span class="source-line-no">210</span><span id="line-210">        this.stripLeadingAndTrailingQuotes = null;</span>
<span class="source-line-no">211</span><span id="line-211">    }</span>
<span class="source-line-no">212</span><span id="line-212"></span>
<span class="source-line-no">213</span><span id="line-213">    /**</span>
<span class="source-line-no">214</span><span id="line-214">     * Creates a new DefaultParser instance with the specified partial matching and quote</span>
<span class="source-line-no">215</span><span id="line-215">     * stripping policy.</span>
<span class="source-line-no">216</span><span id="line-216">     *</span>
<span class="source-line-no">217</span><span id="line-217">     * @param allowPartialMatching if partial matching of long options shall be enabled</span>
<span class="source-line-no">218</span><span id="line-218">     * @param stripLeadingAndTrailingQuotes if balanced outer double quoutes should be stripped</span>
<span class="source-line-no">219</span><span id="line-219">     */</span>
<span class="source-line-no">220</span><span id="line-220">    private DefaultParser(final boolean allowPartialMatching,</span>
<span class="source-line-no">221</span><span id="line-221">            final Boolean stripLeadingAndTrailingQuotes) {</span>
<span class="source-line-no">222</span><span id="line-222">        this.allowPartialMatching = allowPartialMatching;</span>
<span class="source-line-no">223</span><span id="line-223">        this.stripLeadingAndTrailingQuotes = stripLeadingAndTrailingQuotes;</span>
<span class="source-line-no">224</span><span id="line-224">    }</span>
<span class="source-line-no">225</span><span id="line-225"></span>
<span class="source-line-no">226</span><span id="line-226">    /**</span>
<span class="source-line-no">227</span><span id="line-227">     * Throws a {@link MissingArgumentException} if the current option didn't receive the number of arguments expected.</span>
<span class="source-line-no">228</span><span id="line-228">     */</span>
<span class="source-line-no">229</span><span id="line-229">    private void checkRequiredArgs() throws ParseException {</span>
<span class="source-line-no">230</span><span id="line-230">        if (currentOption != null &amp;&amp; currentOption.requiresArg()) {</span>
<span class="source-line-no">231</span><span id="line-231">            throw new MissingArgumentException(currentOption);</span>
<span class="source-line-no">232</span><span id="line-232">        }</span>
<span class="source-line-no">233</span><span id="line-233">    }</span>
<span class="source-line-no">234</span><span id="line-234"></span>
<span class="source-line-no">235</span><span id="line-235">    /**</span>
<span class="source-line-no">236</span><span id="line-236">     * Throws a {@link MissingOptionException} if all of the required options are not present.</span>
<span class="source-line-no">237</span><span id="line-237">     *</span>
<span class="source-line-no">238</span><span id="line-238">     * @throws MissingOptionException if any of the required Options are not present.</span>
<span class="source-line-no">239</span><span id="line-239">     */</span>
<span class="source-line-no">240</span><span id="line-240">    protected void checkRequiredOptions() throws MissingOptionException {</span>
<span class="source-line-no">241</span><span id="line-241">        // if there are required options that have not been processed</span>
<span class="source-line-no">242</span><span id="line-242">        if (!expectedOpts.isEmpty()) {</span>
<span class="source-line-no">243</span><span id="line-243">            throw new MissingOptionException(expectedOpts);</span>
<span class="source-line-no">244</span><span id="line-244">        }</span>
<span class="source-line-no">245</span><span id="line-245">    }</span>
<span class="source-line-no">246</span><span id="line-246"></span>
<span class="source-line-no">247</span><span id="line-247">    /**</span>
<span class="source-line-no">248</span><span id="line-248">     * Searches for a prefix that is the long name of an option (-Xmx512m)</span>
<span class="source-line-no">249</span><span id="line-249">     *</span>
<span class="source-line-no">250</span><span id="line-250">     * @param token</span>
<span class="source-line-no">251</span><span id="line-251">     */</span>
<span class="source-line-no">252</span><span id="line-252">    private String getLongPrefix(final String token) {</span>
<span class="source-line-no">253</span><span id="line-253">        final String t = Util.stripLeadingHyphens(token);</span>
<span class="source-line-no">254</span><span id="line-254"></span>
<span class="source-line-no">255</span><span id="line-255">        int i;</span>
<span class="source-line-no">256</span><span id="line-256">        String opt = null;</span>
<span class="source-line-no">257</span><span id="line-257">        for (i = t.length() - 2; i &gt; 1; i--) {</span>
<span class="source-line-no">258</span><span id="line-258">            final String prefix = t.substring(0, i);</span>
<span class="source-line-no">259</span><span id="line-259">            if (options.hasLongOption(prefix)) {</span>
<span class="source-line-no">260</span><span id="line-260">                opt = prefix;</span>
<span class="source-line-no">261</span><span id="line-261">                break;</span>
<span class="source-line-no">262</span><span id="line-262">            }</span>
<span class="source-line-no">263</span><span id="line-263">        }</span>
<span class="source-line-no">264</span><span id="line-264"></span>
<span class="source-line-no">265</span><span id="line-265">        return opt;</span>
<span class="source-line-no">266</span><span id="line-266">    }</span>
<span class="source-line-no">267</span><span id="line-267"></span>
<span class="source-line-no">268</span><span id="line-268">    /**</span>
<span class="source-line-no">269</span><span id="line-269">     * Gets a list of matching option strings for the given token, depending on the selected partial matching policy.</span>
<span class="source-line-no">270</span><span id="line-270">     *</span>
<span class="source-line-no">271</span><span id="line-271">     * @param token the token (may contain leading dashes)</span>
<span class="source-line-no">272</span><span id="line-272">     * @return the list of matching option strings or an empty list if no matching option could be found</span>
<span class="source-line-no">273</span><span id="line-273">     */</span>
<span class="source-line-no">274</span><span id="line-274">    private List&lt;String&gt; getMatchingLongOptions(final String token) {</span>
<span class="source-line-no">275</span><span id="line-275">        if (allowPartialMatching) {</span>
<span class="source-line-no">276</span><span id="line-276">            return options.getMatchingOptions(token);</span>
<span class="source-line-no">277</span><span id="line-277">        }</span>
<span class="source-line-no">278</span><span id="line-278">        final List&lt;String&gt; matches = new ArrayList&lt;&gt;(1);</span>
<span class="source-line-no">279</span><span id="line-279">        if (options.hasLongOption(token)) {</span>
<span class="source-line-no">280</span><span id="line-280">            final Option option = options.getOption(token);</span>
<span class="source-line-no">281</span><span id="line-281">            matches.add(option.getLongOpt());</span>
<span class="source-line-no">282</span><span id="line-282">        }</span>
<span class="source-line-no">283</span><span id="line-283"></span>
<span class="source-line-no">284</span><span id="line-284">        return matches;</span>
<span class="source-line-no">285</span><span id="line-285">    }</span>
<span class="source-line-no">286</span><span id="line-286"></span>
<span class="source-line-no">287</span><span id="line-287">    /**</span>
<span class="source-line-no">288</span><span id="line-288">     * Breaks {@code token} into its constituent parts using the following algorithm.</span>
<span class="source-line-no">289</span><span id="line-289">     *</span>
<span class="source-line-no">290</span><span id="line-290">     * &lt;ul&gt;</span>
<span class="source-line-no">291</span><span id="line-291">     * &lt;li&gt;ignore the first character ("&lt;b&gt;-&lt;/b&gt;")&lt;/li&gt;</span>
<span class="source-line-no">292</span><span id="line-292">     * &lt;li&gt;for each remaining character check if an {@link Option} exists with that id.&lt;/li&gt;</span>
<span class="source-line-no">293</span><span id="line-293">     * &lt;li&gt;if an {@link Option} does exist then add that character prepended with "&lt;b&gt;-&lt;/b&gt;" to the list of processed</span>
<span class="source-line-no">294</span><span id="line-294">     * tokens.&lt;/li&gt;</span>
<span class="source-line-no">295</span><span id="line-295">     * &lt;li&gt;if the {@link Option} can have an argument value and there are remaining characters in the token then add the</span>
<span class="source-line-no">296</span><span id="line-296">     * remaining characters as a token to the list of processed tokens.&lt;/li&gt;</span>
<span class="source-line-no">297</span><span id="line-297">     * &lt;li&gt;if an {@link Option} does &lt;b&gt;NOT&lt;/b&gt; exist &lt;b&gt;AND&lt;/b&gt; {@code stopAtNonOption} &lt;b&gt;IS&lt;/b&gt; set then add the</span>
<span class="source-line-no">298</span><span id="line-298">     * special token "&lt;b&gt;--&lt;/b&gt;" followed by the remaining characters and also the remaining tokens directly to the</span>
<span class="source-line-no">299</span><span id="line-299">     * processed tokens list.&lt;/li&gt;</span>
<span class="source-line-no">300</span><span id="line-300">     * &lt;li&gt;if an {@link Option} does &lt;b&gt;NOT&lt;/b&gt; exist &lt;b&gt;AND&lt;/b&gt; {@code stopAtNonOption} &lt;b&gt;IS NOT&lt;/b&gt; set then add</span>
<span class="source-line-no">301</span><span id="line-301">     * that character prepended with "&lt;b&gt;-&lt;/b&gt;".&lt;/li&gt;</span>
<span class="source-line-no">302</span><span id="line-302">     * &lt;/ul&gt;</span>
<span class="source-line-no">303</span><span id="line-303">     *</span>
<span class="source-line-no">304</span><span id="line-304">     * @param token The current token to be &lt;b&gt;burst&lt;/b&gt; at the first non-Option encountered.</span>
<span class="source-line-no">305</span><span id="line-305">     * @throws ParseException if there are any problems encountered while parsing the command line token.</span>
<span class="source-line-no">306</span><span id="line-306">     */</span>
<span class="source-line-no">307</span><span id="line-307">    protected void handleConcatenatedOptions(final String token) throws ParseException {</span>
<span class="source-line-no">308</span><span id="line-308">        for (int i = 1; i &lt; token.length(); i++) {</span>
<span class="source-line-no">309</span><span id="line-309">            final String ch = String.valueOf(token.charAt(i));</span>
<span class="source-line-no">310</span><span id="line-310"></span>
<span class="source-line-no">311</span><span id="line-311">            if (!options.hasOption(ch)) {</span>
<span class="source-line-no">312</span><span id="line-312">                handleUnknownToken(stopAtNonOption &amp;&amp; i &gt; 1 ? token.substring(i) : token);</span>
<span class="source-line-no">313</span><span id="line-313">                break;</span>
<span class="source-line-no">314</span><span id="line-314">            }</span>
<span class="source-line-no">315</span><span id="line-315">            handleOption(options.getOption(ch));</span>
<span class="source-line-no">316</span><span id="line-316"></span>
<span class="source-line-no">317</span><span id="line-317">            if (currentOption != null &amp;&amp; token.length() != i + 1) {</span>
<span class="source-line-no">318</span><span id="line-318">                // add the trail as an argument of the option</span>
<span class="source-line-no">319</span><span id="line-319">                currentOption.addValueForProcessing(stripLeadingAndTrailingQuotesDefaultOff(token.substring(i + 1)));</span>
<span class="source-line-no">320</span><span id="line-320">                break;</span>
<span class="source-line-no">321</span><span id="line-321">            }</span>
<span class="source-line-no">322</span><span id="line-322">        }</span>
<span class="source-line-no">323</span><span id="line-323">    }</span>
<span class="source-line-no">324</span><span id="line-324"></span>
<span class="source-line-no">325</span><span id="line-325">    /**</span>
<span class="source-line-no">326</span><span id="line-326">     * Handles the following tokens:</span>
<span class="source-line-no">327</span><span id="line-327">     *</span>
<span class="source-line-no">328</span><span id="line-328">     * --L --L=V --L V --l</span>
<span class="source-line-no">329</span><span id="line-329">     *</span>
<span class="source-line-no">330</span><span id="line-330">     * @param token the command line token to handle</span>
<span class="source-line-no">331</span><span id="line-331">     */</span>
<span class="source-line-no">332</span><span id="line-332">    private void handleLongOption(final String token) throws ParseException {</span>
<span class="source-line-no">333</span><span id="line-333">        if (token.indexOf('=') == -1) {</span>
<span class="source-line-no">334</span><span id="line-334">            handleLongOptionWithoutEqual(token);</span>
<span class="source-line-no">335</span><span id="line-335">        } else {</span>
<span class="source-line-no">336</span><span id="line-336">            handleLongOptionWithEqual(token);</span>
<span class="source-line-no">337</span><span id="line-337">        }</span>
<span class="source-line-no">338</span><span id="line-338">    }</span>
<span class="source-line-no">339</span><span id="line-339"></span>
<span class="source-line-no">340</span><span id="line-340">    /**</span>
<span class="source-line-no">341</span><span id="line-341">     * Handles the following tokens:</span>
<span class="source-line-no">342</span><span id="line-342">     *</span>
<span class="source-line-no">343</span><span id="line-343">     * --L=V -L=V --l=V -l=V</span>
<span class="source-line-no">344</span><span id="line-344">     *</span>
<span class="source-line-no">345</span><span id="line-345">     * @param token the command line token to handle</span>
<span class="source-line-no">346</span><span id="line-346">     */</span>
<span class="source-line-no">347</span><span id="line-347">    private void handleLongOptionWithEqual(final String token) throws ParseException {</span>
<span class="source-line-no">348</span><span id="line-348">        final int pos = token.indexOf('=');</span>
<span class="source-line-no">349</span><span id="line-349"></span>
<span class="source-line-no">350</span><span id="line-350">        final String value = token.substring(pos + 1);</span>
<span class="source-line-no">351</span><span id="line-351"></span>
<span class="source-line-no">352</span><span id="line-352">        final String opt = token.substring(0, pos);</span>
<span class="source-line-no">353</span><span id="line-353"></span>
<span class="source-line-no">354</span><span id="line-354">        final List&lt;String&gt; matchingOpts = getMatchingLongOptions(opt);</span>
<span class="source-line-no">355</span><span id="line-355">        if (matchingOpts.isEmpty()) {</span>
<span class="source-line-no">356</span><span id="line-356">            handleUnknownToken(currentToken);</span>
<span class="source-line-no">357</span><span id="line-357">        } else if (matchingOpts.size() &gt; 1 &amp;&amp; !options.hasLongOption(opt)) {</span>
<span class="source-line-no">358</span><span id="line-358">            throw new AmbiguousOptionException(opt, matchingOpts);</span>
<span class="source-line-no">359</span><span id="line-359">        } else {</span>
<span class="source-line-no">360</span><span id="line-360">            final String key = options.hasLongOption(opt) ? opt : matchingOpts.get(0);</span>
<span class="source-line-no">361</span><span id="line-361">            final Option option = options.getOption(key);</span>
<span class="source-line-no">362</span><span id="line-362"></span>
<span class="source-line-no">363</span><span id="line-363">            if (option.acceptsArg()) {</span>
<span class="source-line-no">364</span><span id="line-364">                handleOption(option);</span>
<span class="source-line-no">365</span><span id="line-365">                currentOption.addValueForProcessing(stripLeadingAndTrailingQuotesDefaultOff(value));</span>
<span class="source-line-no">366</span><span id="line-366">                currentOption = null;</span>
<span class="source-line-no">367</span><span id="line-367">            } else {</span>
<span class="source-line-no">368</span><span id="line-368">                handleUnknownToken(currentToken);</span>
<span class="source-line-no">369</span><span id="line-369">            }</span>
<span class="source-line-no">370</span><span id="line-370">        }</span>
<span class="source-line-no">371</span><span id="line-371">    }</span>
<span class="source-line-no">372</span><span id="line-372"></span>
<span class="source-line-no">373</span><span id="line-373">    /**</span>
<span class="source-line-no">374</span><span id="line-374">     * Handles the following tokens:</span>
<span class="source-line-no">375</span><span id="line-375">     *</span>
<span class="source-line-no">376</span><span id="line-376">     * --L -L --l -l</span>
<span class="source-line-no">377</span><span id="line-377">     *</span>
<span class="source-line-no">378</span><span id="line-378">     * @param token the command line token to handle</span>
<span class="source-line-no">379</span><span id="line-379">     */</span>
<span class="source-line-no">380</span><span id="line-380">    private void handleLongOptionWithoutEqual(final String token) throws ParseException {</span>
<span class="source-line-no">381</span><span id="line-381">        final List&lt;String&gt; matchingOpts = getMatchingLongOptions(token);</span>
<span class="source-line-no">382</span><span id="line-382">        if (matchingOpts.isEmpty()) {</span>
<span class="source-line-no">383</span><span id="line-383">            handleUnknownToken(currentToken);</span>
<span class="source-line-no">384</span><span id="line-384">        } else if (matchingOpts.size() &gt; 1 &amp;&amp; !options.hasLongOption(token)) {</span>
<span class="source-line-no">385</span><span id="line-385">            throw new AmbiguousOptionException(token, matchingOpts);</span>
<span class="source-line-no">386</span><span id="line-386">        } else {</span>
<span class="source-line-no">387</span><span id="line-387">            final String key = options.hasLongOption(token) ? token : matchingOpts.get(0);</span>
<span class="source-line-no">388</span><span id="line-388">            handleOption(options.getOption(key));</span>
<span class="source-line-no">389</span><span id="line-389">        }</span>
<span class="source-line-no">390</span><span id="line-390">    }</span>
<span class="source-line-no">391</span><span id="line-391"></span>
<span class="source-line-no">392</span><span id="line-392">    private void handleOption(Option option) throws ParseException {</span>
<span class="source-line-no">393</span><span id="line-393">        // check the previous option before handling the next one</span>
<span class="source-line-no">394</span><span id="line-394">        checkRequiredArgs();</span>
<span class="source-line-no">395</span><span id="line-395"></span>
<span class="source-line-no">396</span><span id="line-396">        option = (Option) option.clone();</span>
<span class="source-line-no">397</span><span id="line-397"></span>
<span class="source-line-no">398</span><span id="line-398">        updateRequiredOptions(option);</span>
<span class="source-line-no">399</span><span id="line-399"></span>
<span class="source-line-no">400</span><span id="line-400">        cmd.addOption(option);</span>
<span class="source-line-no">401</span><span id="line-401"></span>
<span class="source-line-no">402</span><span id="line-402">        if (option.hasArg()) {</span>
<span class="source-line-no">403</span><span id="line-403">            currentOption = option;</span>
<span class="source-line-no">404</span><span id="line-404">        } else {</span>
<span class="source-line-no">405</span><span id="line-405">            currentOption = null;</span>
<span class="source-line-no">406</span><span id="line-406">        }</span>
<span class="source-line-no">407</span><span id="line-407">    }</span>
<span class="source-line-no">408</span><span id="line-408"></span>
<span class="source-line-no">409</span><span id="line-409">    /**</span>
<span class="source-line-no">410</span><span id="line-410">     * Sets the values of Options using the values in {@code properties}.</span>
<span class="source-line-no">411</span><span id="line-411">     *</span>
<span class="source-line-no">412</span><span id="line-412">     * @param properties The value properties to be processed.</span>
<span class="source-line-no">413</span><span id="line-413">     */</span>
<span class="source-line-no">414</span><span id="line-414">    private void handleProperties(final Properties properties) throws ParseException {</span>
<span class="source-line-no">415</span><span id="line-415">        if (properties == null) {</span>
<span class="source-line-no">416</span><span id="line-416">            return;</span>
<span class="source-line-no">417</span><span id="line-417">        }</span>
<span class="source-line-no">418</span><span id="line-418"></span>
<span class="source-line-no">419</span><span id="line-419">        for (final Enumeration&lt;?&gt; e = properties.propertyNames(); e.hasMoreElements();) {</span>
<span class="source-line-no">420</span><span id="line-420">            final String option = e.nextElement().toString();</span>
<span class="source-line-no">421</span><span id="line-421"></span>
<span class="source-line-no">422</span><span id="line-422">            final Option opt = options.getOption(option);</span>
<span class="source-line-no">423</span><span id="line-423">            if (opt == null) {</span>
<span class="source-line-no">424</span><span id="line-424">                throw new UnrecognizedOptionException("Default option wasn't defined", option);</span>
<span class="source-line-no">425</span><span id="line-425">            }</span>
<span class="source-line-no">426</span><span id="line-426"></span>
<span class="source-line-no">427</span><span id="line-427">            // if the option is part of a group, check if another option of the group has been selected</span>
<span class="source-line-no">428</span><span id="line-428">            final OptionGroup group = options.getOptionGroup(opt);</span>
<span class="source-line-no">429</span><span id="line-429">            final boolean selected = group != null &amp;&amp; group.getSelected() != null;</span>
<span class="source-line-no">430</span><span id="line-430"></span>
<span class="source-line-no">431</span><span id="line-431">            if (!cmd.hasOption(option) &amp;&amp; !selected) {</span>
<span class="source-line-no">432</span><span id="line-432">                // get the value from the properties</span>
<span class="source-line-no">433</span><span id="line-433">                final String value = properties.getProperty(option);</span>
<span class="source-line-no">434</span><span id="line-434"></span>
<span class="source-line-no">435</span><span id="line-435">                if (opt.hasArg()) {</span>
<span class="source-line-no">436</span><span id="line-436">                    if (opt.getValues() == null || opt.getValues().length == 0) {</span>
<span class="source-line-no">437</span><span id="line-437">                        opt.addValueForProcessing(stripLeadingAndTrailingQuotesDefaultOff(value));</span>
<span class="source-line-no">438</span><span id="line-438">                    }</span>
<span class="source-line-no">439</span><span id="line-439">                } else if (!("yes".equalsIgnoreCase(value) || "true".equalsIgnoreCase(value) || "1".equalsIgnoreCase(value))) {</span>
<span class="source-line-no">440</span><span id="line-440">                    // if the value is not yes, true or 1 then don't add the option to the CommandLine</span>
<span class="source-line-no">441</span><span id="line-441">                    continue;</span>
<span class="source-line-no">442</span><span id="line-442">                }</span>
<span class="source-line-no">443</span><span id="line-443"></span>
<span class="source-line-no">444</span><span id="line-444">                handleOption(opt);</span>
<span class="source-line-no">445</span><span id="line-445">                currentOption = null;</span>
<span class="source-line-no">446</span><span id="line-446">            }</span>
<span class="source-line-no">447</span><span id="line-447">        }</span>
<span class="source-line-no">448</span><span id="line-448">    }</span>
<span class="source-line-no">449</span><span id="line-449"></span>
<span class="source-line-no">450</span><span id="line-450">    /**</span>
<span class="source-line-no">451</span><span id="line-451">     * Handles the following tokens:</span>
<span class="source-line-no">452</span><span id="line-452">     *</span>
<span class="source-line-no">453</span><span id="line-453">     * -S -SV -S V -S=V -S1S2 -S1S2 V -SV1=V2</span>
<span class="source-line-no">454</span><span id="line-454">     *</span>
<span class="source-line-no">455</span><span id="line-455">     * -L -LV -L V -L=V -l</span>
<span class="source-line-no">456</span><span id="line-456">     *</span>
<span class="source-line-no">457</span><span id="line-457">     * @param token the command line token to handle</span>
<span class="source-line-no">458</span><span id="line-458">     */</span>
<span class="source-line-no">459</span><span id="line-459">    private void handleShortAndLongOption(final String token) throws ParseException {</span>
<span class="source-line-no">460</span><span id="line-460">        final String t = Util.stripLeadingHyphens(token);</span>
<span class="source-line-no">461</span><span id="line-461"></span>
<span class="source-line-no">462</span><span id="line-462">        final int pos = t.indexOf('=');</span>
<span class="source-line-no">463</span><span id="line-463"></span>
<span class="source-line-no">464</span><span id="line-464">        if (t.length() == 1) {</span>
<span class="source-line-no">465</span><span id="line-465">            // -S</span>
<span class="source-line-no">466</span><span id="line-466">            if (options.hasShortOption(t)) {</span>
<span class="source-line-no">467</span><span id="line-467">                handleOption(options.getOption(t));</span>
<span class="source-line-no">468</span><span id="line-468">            } else {</span>
<span class="source-line-no">469</span><span id="line-469">                handleUnknownToken(token);</span>
<span class="source-line-no">470</span><span id="line-470">            }</span>
<span class="source-line-no">471</span><span id="line-471">        } else if (pos == -1) {</span>
<span class="source-line-no">472</span><span id="line-472">            // no equal sign found (-xxx)</span>
<span class="source-line-no">473</span><span id="line-473">            if (options.hasShortOption(t)) {</span>
<span class="source-line-no">474</span><span id="line-474">                handleOption(options.getOption(t));</span>
<span class="source-line-no">475</span><span id="line-475">            } else if (!getMatchingLongOptions(t).isEmpty()) {</span>
<span class="source-line-no">476</span><span id="line-476">                // -L or -l</span>
<span class="source-line-no">477</span><span id="line-477">                handleLongOptionWithoutEqual(token);</span>
<span class="source-line-no">478</span><span id="line-478">            } else {</span>
<span class="source-line-no">479</span><span id="line-479">                // look for a long prefix (-Xmx512m)</span>
<span class="source-line-no">480</span><span id="line-480">                final String opt = getLongPrefix(t);</span>
<span class="source-line-no">481</span><span id="line-481"></span>
<span class="source-line-no">482</span><span id="line-482">                if (opt != null &amp;&amp; options.getOption(opt).acceptsArg()) {</span>
<span class="source-line-no">483</span><span id="line-483">                    handleOption(options.getOption(opt));</span>
<span class="source-line-no">484</span><span id="line-484">                    currentOption.addValueForProcessing(stripLeadingAndTrailingQuotesDefaultOff(t.substring(opt.length())));</span>
<span class="source-line-no">485</span><span id="line-485">                    currentOption = null;</span>
<span class="source-line-no">486</span><span id="line-486">                } else if (isJavaProperty(t)) {</span>
<span class="source-line-no">487</span><span id="line-487">                    // -SV1 (-Dflag)</span>
<span class="source-line-no">488</span><span id="line-488">                    handleOption(options.getOption(t.substring(0, 1)));</span>
<span class="source-line-no">489</span><span id="line-489">                    currentOption.addValueForProcessing(stripLeadingAndTrailingQuotesDefaultOff(t.substring(1)));</span>
<span class="source-line-no">490</span><span id="line-490">                    currentOption = null;</span>
<span class="source-line-no">491</span><span id="line-491">                } else {</span>
<span class="source-line-no">492</span><span id="line-492">                    // -S1S2S3 or -S1S2V</span>
<span class="source-line-no">493</span><span id="line-493">                    handleConcatenatedOptions(token);</span>
<span class="source-line-no">494</span><span id="line-494">                }</span>
<span class="source-line-no">495</span><span id="line-495">            }</span>
<span class="source-line-no">496</span><span id="line-496">        } else {</span>
<span class="source-line-no">497</span><span id="line-497">            // equal sign found (-xxx=yyy)</span>
<span class="source-line-no">498</span><span id="line-498">            final String opt = t.substring(0, pos);</span>
<span class="source-line-no">499</span><span id="line-499">            final String value = t.substring(pos + 1);</span>
<span class="source-line-no">500</span><span id="line-500"></span>
<span class="source-line-no">501</span><span id="line-501">            if (opt.length() == 1) {</span>
<span class="source-line-no">502</span><span id="line-502">                // -S=V</span>
<span class="source-line-no">503</span><span id="line-503">                final Option option = options.getOption(opt);</span>
<span class="source-line-no">504</span><span id="line-504">                if (option != null &amp;&amp; option.acceptsArg()) {</span>
<span class="source-line-no">505</span><span id="line-505">                    handleOption(option);</span>
<span class="source-line-no">506</span><span id="line-506">                    currentOption.addValueForProcessing(value);</span>
<span class="source-line-no">507</span><span id="line-507">                    currentOption = null;</span>
<span class="source-line-no">508</span><span id="line-508">                } else {</span>
<span class="source-line-no">509</span><span id="line-509">                    handleUnknownToken(token);</span>
<span class="source-line-no">510</span><span id="line-510">                }</span>
<span class="source-line-no">511</span><span id="line-511">            } else if (isJavaProperty(opt)) {</span>
<span class="source-line-no">512</span><span id="line-512">                // -SV1=V2 (-Dkey=value)</span>
<span class="source-line-no">513</span><span id="line-513">                handleOption(options.getOption(opt.substring(0, 1)));</span>
<span class="source-line-no">514</span><span id="line-514">                currentOption.addValueForProcessing(opt.substring(1));</span>
<span class="source-line-no">515</span><span id="line-515">                currentOption.addValueForProcessing(value);</span>
<span class="source-line-no">516</span><span id="line-516">                currentOption = null;</span>
<span class="source-line-no">517</span><span id="line-517">            } else {</span>
<span class="source-line-no">518</span><span id="line-518">                // -L=V or -l=V</span>
<span class="source-line-no">519</span><span id="line-519">                handleLongOptionWithEqual(token);</span>
<span class="source-line-no">520</span><span id="line-520">            }</span>
<span class="source-line-no">521</span><span id="line-521">        }</span>
<span class="source-line-no">522</span><span id="line-522">    }</span>
<span class="source-line-no">523</span><span id="line-523"></span>
<span class="source-line-no">524</span><span id="line-524">    /**</span>
<span class="source-line-no">525</span><span id="line-525">     * Handles any command line token.</span>
<span class="source-line-no">526</span><span id="line-526">     *</span>
<span class="source-line-no">527</span><span id="line-527">     * @param token the command line token to handle</span>
<span class="source-line-no">528</span><span id="line-528">     * @throws ParseException</span>
<span class="source-line-no">529</span><span id="line-529">     */</span>
<span class="source-line-no">530</span><span id="line-530">    private void handleToken(final String token) throws ParseException {</span>
<span class="source-line-no">531</span><span id="line-531">        currentToken = token;</span>
<span class="source-line-no">532</span><span id="line-532"></span>
<span class="source-line-no">533</span><span id="line-533">        if (skipParsing) {</span>
<span class="source-line-no">534</span><span id="line-534">            cmd.addArg(token);</span>
<span class="source-line-no">535</span><span id="line-535">        } else if ("--".equals(token)) {</span>
<span class="source-line-no">536</span><span id="line-536">            skipParsing = true;</span>
<span class="source-line-no">537</span><span id="line-537">        } else if (currentOption != null &amp;&amp; currentOption.acceptsArg() &amp;&amp; isArgument(token)) {</span>
<span class="source-line-no">538</span><span id="line-538">            currentOption.addValueForProcessing(stripLeadingAndTrailingQuotesDefaultOn(token));</span>
<span class="source-line-no">539</span><span id="line-539">        } else if (token.startsWith("--")) {</span>
<span class="source-line-no">540</span><span id="line-540">            handleLongOption(token);</span>
<span class="source-line-no">541</span><span id="line-541">        } else if (token.startsWith("-") &amp;&amp; !"-".equals(token)) {</span>
<span class="source-line-no">542</span><span id="line-542">            handleShortAndLongOption(token);</span>
<span class="source-line-no">543</span><span id="line-543">        } else {</span>
<span class="source-line-no">544</span><span id="line-544">            handleUnknownToken(token);</span>
<span class="source-line-no">545</span><span id="line-545">        }</span>
<span class="source-line-no">546</span><span id="line-546"></span>
<span class="source-line-no">547</span><span id="line-547">        if (currentOption != null &amp;&amp; !currentOption.acceptsArg()) {</span>
<span class="source-line-no">548</span><span id="line-548">            currentOption = null;</span>
<span class="source-line-no">549</span><span id="line-549">        }</span>
<span class="source-line-no">550</span><span id="line-550">    }</span>
<span class="source-line-no">551</span><span id="line-551"></span>
<span class="source-line-no">552</span><span id="line-552">    /**</span>
<span class="source-line-no">553</span><span id="line-553">     * Handles an unknown token. If the token starts with a dash an UnrecognizedOptionException is thrown. Otherwise the</span>
<span class="source-line-no">554</span><span id="line-554">     * token is added to the arguments of the command line. If the stopAtNonOption flag is set, this stops the parsing and</span>
<span class="source-line-no">555</span><span id="line-555">     * the remaining tokens are added as-is in the arguments of the command line.</span>
<span class="source-line-no">556</span><span id="line-556">     *</span>
<span class="source-line-no">557</span><span id="line-557">     * @param token the command line token to handle</span>
<span class="source-line-no">558</span><span id="line-558">     */</span>
<span class="source-line-no">559</span><span id="line-559">    private void handleUnknownToken(final String token) throws ParseException {</span>
<span class="source-line-no">560</span><span id="line-560">        if (token.startsWith("-") &amp;&amp; token.length() &gt; 1 &amp;&amp; !stopAtNonOption) {</span>
<span class="source-line-no">561</span><span id="line-561">            throw new UnrecognizedOptionException("Unrecognized option: " + token, token);</span>
<span class="source-line-no">562</span><span id="line-562">        }</span>
<span class="source-line-no">563</span><span id="line-563"></span>
<span class="source-line-no">564</span><span id="line-564">        cmd.addArg(token);</span>
<span class="source-line-no">565</span><span id="line-565">        if (stopAtNonOption) {</span>
<span class="source-line-no">566</span><span id="line-566">            skipParsing = true;</span>
<span class="source-line-no">567</span><span id="line-567">        }</span>
<span class="source-line-no">568</span><span id="line-568">    }</span>
<span class="source-line-no">569</span><span id="line-569"></span>
<span class="source-line-no">570</span><span id="line-570">    /**</span>
<span class="source-line-no">571</span><span id="line-571">     * Tests if the token is a valid argument.</span>
<span class="source-line-no">572</span><span id="line-572">     *</span>
<span class="source-line-no">573</span><span id="line-573">     * @param token</span>
<span class="source-line-no">574</span><span id="line-574">     */</span>
<span class="source-line-no">575</span><span id="line-575">    private boolean isArgument(final String token) {</span>
<span class="source-line-no">576</span><span id="line-576">        return !isOption(token) || isNegativeNumber(token);</span>
<span class="source-line-no">577</span><span id="line-577">    }</span>
<span class="source-line-no">578</span><span id="line-578"></span>
<span class="source-line-no">579</span><span id="line-579">    /**</span>
<span class="source-line-no">580</span><span id="line-580">     * Tests if the specified token is a Java-like property (-Dkey=value).</span>
<span class="source-line-no">581</span><span id="line-581">     */</span>
<span class="source-line-no">582</span><span id="line-582">    private boolean isJavaProperty(final String token) {</span>
<span class="source-line-no">583</span><span id="line-583">        final String opt = token.isEmpty() ? null : token.substring(0, 1);</span>
<span class="source-line-no">584</span><span id="line-584">        final Option option = options.getOption(opt);</span>
<span class="source-line-no">585</span><span id="line-585"></span>
<span class="source-line-no">586</span><span id="line-586">        return option != null &amp;&amp; (option.getArgs() &gt;= 2 || option.getArgs() == Option.UNLIMITED_VALUES);</span>
<span class="source-line-no">587</span><span id="line-587">    }</span>
<span class="source-line-no">588</span><span id="line-588"></span>
<span class="source-line-no">589</span><span id="line-589">    /**</span>
<span class="source-line-no">590</span><span id="line-590">     * Tests if the token looks like a long option.</span>
<span class="source-line-no">591</span><span id="line-591">     *</span>
<span class="source-line-no">592</span><span id="line-592">     * @param token</span>
<span class="source-line-no">593</span><span id="line-593">     */</span>
<span class="source-line-no">594</span><span id="line-594">    private boolean isLongOption(final String token) {</span>
<span class="source-line-no">595</span><span id="line-595">        if (token == null || !token.startsWith("-") || token.length() == 1) {</span>
<span class="source-line-no">596</span><span id="line-596">            return false;</span>
<span class="source-line-no">597</span><span id="line-597">        }</span>
<span class="source-line-no">598</span><span id="line-598"></span>
<span class="source-line-no">599</span><span id="line-599">        final int pos = token.indexOf("=");</span>
<span class="source-line-no">600</span><span id="line-600">        final String t = pos == -1 ? token : token.substring(0, pos);</span>
<span class="source-line-no">601</span><span id="line-601"></span>
<span class="source-line-no">602</span><span id="line-602">        if (!getMatchingLongOptions(t).isEmpty()) {</span>
<span class="source-line-no">603</span><span id="line-603">            // long or partial long options (--L, -L, --L=V, -L=V, --l, --l=V)</span>
<span class="source-line-no">604</span><span id="line-604">            return true;</span>
<span class="source-line-no">605</span><span id="line-605">        }</span>
<span class="source-line-no">606</span><span id="line-606">        if (getLongPrefix(token) != null &amp;&amp; !token.startsWith("--")) {</span>
<span class="source-line-no">607</span><span id="line-607">            // -LV</span>
<span class="source-line-no">608</span><span id="line-608">            return true;</span>
<span class="source-line-no">609</span><span id="line-609">        }</span>
<span class="source-line-no">610</span><span id="line-610"></span>
<span class="source-line-no">611</span><span id="line-611">        return false;</span>
<span class="source-line-no">612</span><span id="line-612">    }</span>
<span class="source-line-no">613</span><span id="line-613"></span>
<span class="source-line-no">614</span><span id="line-614">    /**</span>
<span class="source-line-no">615</span><span id="line-615">     * Tests if the token is a negative number.</span>
<span class="source-line-no">616</span><span id="line-616">     *</span>
<span class="source-line-no">617</span><span id="line-617">     * @param token</span>
<span class="source-line-no">618</span><span id="line-618">     */</span>
<span class="source-line-no">619</span><span id="line-619">    private boolean isNegativeNumber(final String token) {</span>
<span class="source-line-no">620</span><span id="line-620">        try {</span>
<span class="source-line-no">621</span><span id="line-621">            Double.parseDouble(token);</span>
<span class="source-line-no">622</span><span id="line-622">            return true;</span>
<span class="source-line-no">623</span><span id="line-623">        } catch (final NumberFormatException e) {</span>
<span class="source-line-no">624</span><span id="line-624">            return false;</span>
<span class="source-line-no">625</span><span id="line-625">        }</span>
<span class="source-line-no">626</span><span id="line-626">    }</span>
<span class="source-line-no">627</span><span id="line-627"></span>
<span class="source-line-no">628</span><span id="line-628">    /**</span>
<span class="source-line-no">629</span><span id="line-629">     * Tests if the token looks like an option.</span>
<span class="source-line-no">630</span><span id="line-630">     *</span>
<span class="source-line-no">631</span><span id="line-631">     * @param token</span>
<span class="source-line-no">632</span><span id="line-632">     */</span>
<span class="source-line-no">633</span><span id="line-633">    private boolean isOption(final String token) {</span>
<span class="source-line-no">634</span><span id="line-634">        return isLongOption(token) || isShortOption(token);</span>
<span class="source-line-no">635</span><span id="line-635">    }</span>
<span class="source-line-no">636</span><span id="line-636"></span>
<span class="source-line-no">637</span><span id="line-637">    /**</span>
<span class="source-line-no">638</span><span id="line-638">     * Tests if the token looks like a short option.</span>
<span class="source-line-no">639</span><span id="line-639">     *</span>
<span class="source-line-no">640</span><span id="line-640">     * @param token</span>
<span class="source-line-no">641</span><span id="line-641">     */</span>
<span class="source-line-no">642</span><span id="line-642">    private boolean isShortOption(final String token) {</span>
<span class="source-line-no">643</span><span id="line-643">        // short options (-S, -SV, -S=V, -SV1=V2, -S1S2)</span>
<span class="source-line-no">644</span><span id="line-644">        if (token == null || !token.startsWith("-") || token.length() == 1) {</span>
<span class="source-line-no">645</span><span id="line-645">            return false;</span>
<span class="source-line-no">646</span><span id="line-646">        }</span>
<span class="source-line-no">647</span><span id="line-647"></span>
<span class="source-line-no">648</span><span id="line-648">        // remove leading "-" and "=value"</span>
<span class="source-line-no">649</span><span id="line-649">        final int pos = token.indexOf("=");</span>
<span class="source-line-no">650</span><span id="line-650">        final String optName = pos == -1 ? token.substring(1) : token.substring(1, pos);</span>
<span class="source-line-no">651</span><span id="line-651">        if (options.hasShortOption(optName)) {</span>
<span class="source-line-no">652</span><span id="line-652">            return true;</span>
<span class="source-line-no">653</span><span id="line-653">        }</span>
<span class="source-line-no">654</span><span id="line-654">        // check for several concatenated short options</span>
<span class="source-line-no">655</span><span id="line-655">        return !optName.isEmpty() &amp;&amp; options.hasShortOption(String.valueOf(optName.charAt(0)));</span>
<span class="source-line-no">656</span><span id="line-656">    }</span>
<span class="source-line-no">657</span><span id="line-657"></span>
<span class="source-line-no">658</span><span id="line-658">    @Override</span>
<span class="source-line-no">659</span><span id="line-659">    public CommandLine parse(final Options options, final String[] arguments) throws ParseException {</span>
<span class="source-line-no">660</span><span id="line-660">        return parse(options, arguments, null);</span>
<span class="source-line-no">661</span><span id="line-661">    }</span>
<span class="source-line-no">662</span><span id="line-662"></span>
<span class="source-line-no">663</span><span id="line-663">    @Override</span>
<span class="source-line-no">664</span><span id="line-664">    public CommandLine parse(final Options options, final String[] arguments, final boolean stopAtNonOption) throws ParseException {</span>
<span class="source-line-no">665</span><span id="line-665">        return parse(options, arguments, null, stopAtNonOption);</span>
<span class="source-line-no">666</span><span id="line-666">    }</span>
<span class="source-line-no">667</span><span id="line-667"></span>
<span class="source-line-no">668</span><span id="line-668">    /**</span>
<span class="source-line-no">669</span><span id="line-669">     * Parses the arguments according to the specified options and properties.</span>
<span class="source-line-no">670</span><span id="line-670">     *</span>
<span class="source-line-no">671</span><span id="line-671">     * @param options the specified Options</span>
<span class="source-line-no">672</span><span id="line-672">     * @param arguments the command line arguments</span>
<span class="source-line-no">673</span><span id="line-673">     * @param properties command line option name-value pairs</span>
<span class="source-line-no">674</span><span id="line-674">     * @return the list of atomic option and value tokens</span>
<span class="source-line-no">675</span><span id="line-675">     *</span>
<span class="source-line-no">676</span><span id="line-676">     * @throws ParseException if there are any problems encountered while parsing the command line tokens.</span>
<span class="source-line-no">677</span><span id="line-677">     */</span>
<span class="source-line-no">678</span><span id="line-678">    public CommandLine parse(final Options options, final String[] arguments, final Properties properties) throws ParseException {</span>
<span class="source-line-no">679</span><span id="line-679">        return parse(options, arguments, properties, false);</span>
<span class="source-line-no">680</span><span id="line-680">    }</span>
<span class="source-line-no">681</span><span id="line-681"></span>
<span class="source-line-no">682</span><span id="line-682">    /**</span>
<span class="source-line-no">683</span><span id="line-683">     * Parses the arguments according to the specified options and properties.</span>
<span class="source-line-no">684</span><span id="line-684">     *</span>
<span class="source-line-no">685</span><span id="line-685">     * @param options the specified Options</span>
<span class="source-line-no">686</span><span id="line-686">     * @param arguments the command line arguments</span>
<span class="source-line-no">687</span><span id="line-687">     * @param properties command line option name-value pairs</span>
<span class="source-line-no">688</span><span id="line-688">     * @param stopAtNonOption if {@code true} an unrecognized argument stops the parsing and the remaining arguments</span>
<span class="source-line-no">689</span><span id="line-689">     *        are added to the {@link CommandLine}s args list. If {@code false} an unrecognized argument triggers a</span>
<span class="source-line-no">690</span><span id="line-690">     *        ParseException.</span>
<span class="source-line-no">691</span><span id="line-691">     *</span>
<span class="source-line-no">692</span><span id="line-692">     * @return the list of atomic option and value tokens</span>
<span class="source-line-no">693</span><span id="line-693">     * @throws ParseException if there are any problems encountered while parsing the command line tokens.</span>
<span class="source-line-no">694</span><span id="line-694">     */</span>
<span class="source-line-no">695</span><span id="line-695">    public CommandLine parse(final Options options, final String[] arguments, final Properties properties, final boolean stopAtNonOption)</span>
<span class="source-line-no">696</span><span id="line-696">        throws ParseException {</span>
<span class="source-line-no">697</span><span id="line-697">        this.options = options;</span>
<span class="source-line-no">698</span><span id="line-698">        this.stopAtNonOption = stopAtNonOption;</span>
<span class="source-line-no">699</span><span id="line-699">        skipParsing = false;</span>
<span class="source-line-no">700</span><span id="line-700">        currentOption = null;</span>
<span class="source-line-no">701</span><span id="line-701">        expectedOpts = new ArrayList&lt;&gt;(options.getRequiredOptions());</span>
<span class="source-line-no">702</span><span id="line-702"></span>
<span class="source-line-no">703</span><span id="line-703">        // clear the data from the groups</span>
<span class="source-line-no">704</span><span id="line-704">        for (final OptionGroup group : options.getOptionGroups()) {</span>
<span class="source-line-no">705</span><span id="line-705">            group.setSelected(null);</span>
<span class="source-line-no">706</span><span id="line-706">        }</span>
<span class="source-line-no">707</span><span id="line-707"></span>
<span class="source-line-no">708</span><span id="line-708">        cmd = new CommandLine();</span>
<span class="source-line-no">709</span><span id="line-709"></span>
<span class="source-line-no">710</span><span id="line-710">        if (arguments != null) {</span>
<span class="source-line-no">711</span><span id="line-711">            for (final String argument : arguments) {</span>
<span class="source-line-no">712</span><span id="line-712">                handleToken(argument);</span>
<span class="source-line-no">713</span><span id="line-713">            }</span>
<span class="source-line-no">714</span><span id="line-714">        }</span>
<span class="source-line-no">715</span><span id="line-715"></span>
<span class="source-line-no">716</span><span id="line-716">        // check the arguments of the last option</span>
<span class="source-line-no">717</span><span id="line-717">        checkRequiredArgs();</span>
<span class="source-line-no">718</span><span id="line-718"></span>
<span class="source-line-no">719</span><span id="line-719">        // add the default options</span>
<span class="source-line-no">720</span><span id="line-720">        handleProperties(properties);</span>
<span class="source-line-no">721</span><span id="line-721"></span>
<span class="source-line-no">722</span><span id="line-722">        checkRequiredOptions();</span>
<span class="source-line-no">723</span><span id="line-723"></span>
<span class="source-line-no">724</span><span id="line-724">        return cmd;</span>
<span class="source-line-no">725</span><span id="line-725">    }</span>
<span class="source-line-no">726</span><span id="line-726"></span>
<span class="source-line-no">727</span><span id="line-727">    /**</span>
<span class="source-line-no">728</span><span id="line-728">     * Strips balanced leading and trailing quotes if the stripLeadingAndTrailingQuotes is set</span>
<span class="source-line-no">729</span><span id="line-729">     * If stripLeadingAndTrailingQuotes is null, then do not strip</span>
<span class="source-line-no">730</span><span id="line-730">     *</span>
<span class="source-line-no">731</span><span id="line-731">     * @param token a string</span>
<span class="source-line-no">732</span><span id="line-732">     * @return token with the quotes stripped (if set)</span>
<span class="source-line-no">733</span><span id="line-733">     */</span>
<span class="source-line-no">734</span><span id="line-734">    private String stripLeadingAndTrailingQuotesDefaultOff(final String token) {</span>
<span class="source-line-no">735</span><span id="line-735">        if (stripLeadingAndTrailingQuotes != null &amp;&amp; stripLeadingAndTrailingQuotes) {</span>
<span class="source-line-no">736</span><span id="line-736">            return Util.stripLeadingAndTrailingQuotes(token);</span>
<span class="source-line-no">737</span><span id="line-737">        }</span>
<span class="source-line-no">738</span><span id="line-738">        return token;</span>
<span class="source-line-no">739</span><span id="line-739">    }</span>
<span class="source-line-no">740</span><span id="line-740"></span>
<span class="source-line-no">741</span><span id="line-741">    /**</span>
<span class="source-line-no">742</span><span id="line-742">     * Strips balanced leading and trailing quotes if the stripLeadingAndTrailingQuotes is set</span>
<span class="source-line-no">743</span><span id="line-743">     * If stripLeadingAndTrailingQuotes is null, then do not strip</span>
<span class="source-line-no">744</span><span id="line-744">     *</span>
<span class="source-line-no">745</span><span id="line-745">     * @param token a string</span>
<span class="source-line-no">746</span><span id="line-746">     * @return token with the quotes stripped (if set)</span>
<span class="source-line-no">747</span><span id="line-747">     */</span>
<span class="source-line-no">748</span><span id="line-748">    private String stripLeadingAndTrailingQuotesDefaultOn(final String token) {</span>
<span class="source-line-no">749</span><span id="line-749">        if (stripLeadingAndTrailingQuotes == null || stripLeadingAndTrailingQuotes) {</span>
<span class="source-line-no">750</span><span id="line-750">            return Util.stripLeadingAndTrailingQuotes(token);</span>
<span class="source-line-no">751</span><span id="line-751">        }</span>
<span class="source-line-no">752</span><span id="line-752">        return token;</span>
<span class="source-line-no">753</span><span id="line-753">    }</span>
<span class="source-line-no">754</span><span id="line-754"></span>
<span class="source-line-no">755</span><span id="line-755">    /**</span>
<span class="source-line-no">756</span><span id="line-756">     * Removes the option or its group from the list of expected elements.</span>
<span class="source-line-no">757</span><span id="line-757">     *</span>
<span class="source-line-no">758</span><span id="line-758">     * @param option</span>
<span class="source-line-no">759</span><span id="line-759">     */</span>
<span class="source-line-no">760</span><span id="line-760">    private void updateRequiredOptions(final Option option) throws AlreadySelectedException {</span>
<span class="source-line-no">761</span><span id="line-761">        if (option.isRequired()) {</span>
<span class="source-line-no">762</span><span id="line-762">            expectedOpts.remove(option.getKey());</span>
<span class="source-line-no">763</span><span id="line-763">        }</span>
<span class="source-line-no">764</span><span id="line-764"></span>
<span class="source-line-no">765</span><span id="line-765">        // if the option is in an OptionGroup make that option the selected option of the group</span>
<span class="source-line-no">766</span><span id="line-766">        if (options.getOptionGroup(option) != null) {</span>
<span class="source-line-no">767</span><span id="line-767">            final OptionGroup group = options.getOptionGroup(option);</span>
<span class="source-line-no">768</span><span id="line-768"></span>
<span class="source-line-no">769</span><span id="line-769">            if (group.isRequired()) {</span>
<span class="source-line-no">770</span><span id="line-770">                expectedOpts.remove(group);</span>
<span class="source-line-no">771</span><span id="line-771">            }</span>
<span class="source-line-no">772</span><span id="line-772"></span>
<span class="source-line-no">773</span><span id="line-773">            group.setSelected(option);</span>
<span class="source-line-no">774</span><span id="line-774">        }</span>
<span class="source-line-no">775</span><span id="line-775">    }</span>
<span class="source-line-no">776</span><span id="line-776">}</span>




























































</pre>
</div>
</main>
</body>
</html>
